<!-- <app-experiment-sub-toolbar></app-experiment-sub-toolbar> -->
<mat-toolbar class="ex-title" >
  <span style="margin-left: 15px;"><h1 class="mat-h1">VS Instances</h1></span>
</mat-toolbar>
<div style="padding: 30px 0;" class="ex-container" >
<div fxFlex="100%" fxLayout.xs="column" fxLayout="column" fxLayoutAlign="center center" style="width: 100%">
<div fxFlex="100%" fxLayout.xs="row" fxLayout="row" fxLayoutAlign="left left" class="search-box">
  <div style="padding: 0 40px;">
    <label style="float: left;" for="blueprintFile" class="uploadBtn" (click)="openDialog()">Add new instance</label>
  </div>

  <mat-form-field>
    <mat-label>Filter by Status</mat-label>
    <mat-select (selectionChange)="onStatusSelected($event);" [(value)]="selectedState">
        <mat-option *ngFor="let state of states" [value]="state">
            {{state}}
        </mat-option>
    </mat-select>
  </mat-form-field>
  <button mat-stroked-button aria-label="Clear" (click)="clearFilter(); selectedState=undefined; selectedSite=undefined; $event.stopPropagation()" style="margin-left: 10px;">Clear <mat-icon>close</mat-icon>
  </button>
  </div>
  <table mat-table [dataSource]="dataSource" matSort  class="ex-table full-width-table">
    <!-- Id Column -->
    <ng-container matColumnDef="experimentId">
      <th fxShow.xs="false" mat-header-cell *matHeaderCellDef mat-sort-header>Id</th>
      <td mat-cell *matCellDef="let row"><b>{{row.verticalServiceInstanceId}}</b></td>
    </ng-container>

    <!-- Name column-->
    <ng-container matColumnDef="name">
      <th fxShow.xs="false" mat-header-cell *matHeaderCellDef mat-sort-header>Name</th>
      <td mat-cell *matCellDef="let row"><b>{{row.name}}</b></td>
    </ng-container>
    <!-- ExpD Id Column -->
    <!-- <ng-container matColumnDef="experimentDescriptorId">
      <th fxShow.xs="false" mat-header-cell *matHeaderCellDef mat-sort-header>Descriptor Id</th>
      <td fxShow.xs="false" mat-cell *matCellDef="let row">
        <tr *ngFor="let name of idToExpdId.get(row.experimentId) | keyvalue"><td><a (click)="viewExpDescriptor(name.key)" style="color: saddlebrown;cursor: pointer;">{{name.value}}</a></td></tr>
      </td>
    </ng-container> -->

    <!-- Sites Column -->
    <ng-container matColumnDef="sites">
      <th fxShow.xs="false" mat-header-cell *matHeaderCellDef>Sites</th>
      <td fxShow.xs="false" mat-cell *matCellDef="let row">{{row.testbed}}</td>
    </ng-container>

    <!-- Status Column -->
    <ng-container matColumnDef="status">
        <th fxShow.xs="false" mat-header-cell *matHeaderCellDef>Status</th>
        <td fxShow.xs="false" mat-cell *matCellDef="let row">{{row.status}}</td>
    </ng-container>

     <!-- Execution Status Column -->
     <!-- <ng-container matColumnDef="execStatus">
        <th fxShow.xs="false" mat-header-cell *matHeaderCellDef>Execution Status</th>
        <td fxShow.xs="false" mat-cell *matCellDef="let row" >{{row.executionStatus}}</td>
    </ng-container> -->

    <!-- Button Column -->
    <ng-container  matColumnDef="buttons">
        <th fxShow.xs="false" mat-header-cell *matHeaderCellDef></th>
        <td fxShow.xs="false" mat-cell *matCellDef="let row" style="text-align: left;">
            <!-- <mat-button-toggle-group name="operations" aria-label="Operations" class="margin-all"> -->
              <!-- <mat-button-toggle style="background-color: #b3b3b3;" value="instantiate" (click)="openExecDialog(row.experimentId, row.status, row.experimentDescriptorId);"><mat-icon>launch</mat-icon></mat-button-toggle> -->
              <!-- <mat-button-toggle style="background-color: #b3b3b3;" value="manage"  (click)="openMgmtDialog(row.experimentId, row.status, row.perfDiag);"><mat-icon>build</mat-icon></mat-button-toggle> -->
              <span value="view_experiment" (click)="viewExperiment(row.verticalServiceInstanceId)"><i class="fa fa-eye fa-2x" aria-hidden="true"></i></span>
              <span *ngIf="row.status == 'INSTANTIATED'" style="padding: 0 10px;" value="terminate_experiment" (click)="terminateExperiment(row.verticalServiceInstanceId)"><i class="fa fa-ban fa-2x" aria-hidden="true"></i></span>
              <span value="forcedelete_experiment" (click)="forcedeleteExperiment(row.verticalServiceInstanceId)"><i class="fa fa-trash fa-2x" aria-hidden="true"></i></span>
              <!-- <mat-button-toggle style="background-color: #b3b3b3;" value="view_metrics"  (click)="viewMetrics(row.experimentId)"><mat-icon>multiline_chart</mat-icon></mat-button-toggle> -->
              <!-- <mat-button-toggle style="background-color: #b3b3b3;" value="delete"  (click)="deleteExperiment(row.experimentId)"><mat-icon>delete_forever</mat-icon></mat-button-toggle> -->

              
              <!-- <mat-button-toggle style="background-color: #b3b3b3;" value="instantiate" *ngIf="getRole().indexOf('EXPERIMENTER') >= 0 && ((row.status).indexOf('READY') >= 0 || (row.status).indexOf('INSTANTIATED') >= 0);" (click)="openExecDialog(row.experimentId, row.status, row.experimentDescriptorId);"><mat-icon>launch</mat-icon></mat-button-toggle>
              <mat-button-toggle style="background-color: #b3b3b3;" value="manage" *ngIf="getRole().indexOf('SITE_MANAGER') >= 0 && ((row.status).indexOf('SCHEDULING') >= 0 || (row.status).indexOf('ACCEPTED') >= 0);" (click)="openMgmtDialog(row.experimentId, row.status, row.perfDiag);"><mat-icon>build</mat-icon></mat-button-toggle>
              <mat-button-toggle style="background-color: #b3b3b3;" value="view_descriptor" (click)="viewExperiment(row.experimentId)"><mat-icon>remove_red_eye</mat-icon></mat-button-toggle>
              <mat-button-toggle style="background-color: #b3b3b3;" value="view_metrics" *ngIf="((row.status).indexOf('TERMINATED') >= 0 || (row.status).indexOf('FAILED') >= 0 || (row.status).indexOf('INSTANTIATED') >= 0 || (row.status).indexOf('RUNNING_EXECUTION') >= 0);" (click)="viewMetrics(row.experimentId)"><mat-icon>multiline_chart</mat-icon></mat-button-toggle>
              <mat-button-toggle style="background-color: #b3b3b3;" value="delete" *ngIf="((row.status).indexOf('READY') >= 0 || (row.status).indexOf('TERMINATED') >= 0 || (row.status).indexOf('FAILED') >= 0 || (row.status).indexOf('REFUSED') >= 0)  || ( getRole().indexOf('EXPERIMENTER') >= 0);" (click)="deleteExperiment(row.experimentId)"><mat-icon>delete_forever</mat-icon></mat-button-toggle> -->
            <!-- </mat-button-toggle-group> -->
        </td>
    </ng-container>
    <ng-container matColumnDef="view">
      <th mat-header-cell *matHeaderCellDef>View</th>
      <td mat-cell *matCellDef="let row">
        <span value="view_experiment" (click)="viewExperiment(row.verticalServiceInstanceId)"><i class="fa fa-eye fa-2x" aria-hidden="true"></i></span>
      </td>
      </ng-container>
      <ng-container matColumnDef="terminate">
        <th mat-header-cell *matHeaderCellDef>Terminate</th>
        <td mat-cell *matCellDef="let row">
          <span *ngIf="row.status == 'INSTANTIATED'" style="padding: 0 10px;" value="terminate_experiment" (click)="terminateExperiment(row.verticalServiceInstanceId)"><i class="fa fa-ban fa-2x" aria-hidden="true"></i></span>
              </td>
        </ng-container>
      <ng-container matColumnDef="delete">
          <th mat-header-cell *matHeaderCellDef>Delete</th>
          <td mat-cell *matCellDef="let row">
            <span value="delete_experiment" (click)="deleteExperiment(row.verticalServiceInstanceId)"><i class="fa fa-times-circle fa-2x" aria-hidden="true"></i></span>
          </td>
          </ng-container>
          <ng-container matColumnDef="forcedelete">
              <th mat-header-cell *matHeaderCellDef>Force delete</th>
              <td mat-cell *matCellDef="let row">
                <span value="forcedelete_experiment" (click)="forcedeleteExperiment(row.verticalServiceInstanceId)"><i class="fa fa-trash fa-2x" aria-hidden="true"></i></span>
              </td>
              </ng-container>
    <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
    <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
  </table>

  <mat-paginator #paginator style="width: 100%" fxFlex="100%" fxLayout.xs="row" fxLayout="column" fxLayoutAlign="center center"

      [length]="dataSource?.data.length"
      [pageIndex]="0"
      [pageSize]="50"
      [pageSizeOptions]="[25, 50, 100, 250]"
      class="ex-table paginator-xs">
  </mat-paginator>
</div>
</div>
